diff -ruN ../nakedmudv3.7.9/src/scripts/pyobj.c src/scripts/pyobj.c
--- ../nakedmudv3.7.9/src/scripts/pyobj.c	2009-03-02 01:00:40.000000000 -0500
+++ src/scripts/pyobj.c	2009-04-05 12:44:10.000000000 -0400
@@ -1,8 +1,8 @@
 //*****************************************************************************
 //
-// py_char.c
+// pyobj.c
 //
-// A python extention to allow python scripts to treat MUD characters as an
+// A python extention to allow python scripts to treat MUD objects as a Python
 // object within the script.
 //
 //*****************************************************************************
@@ -874,6 +874,20 @@
   return ret;
 }
 
+PyObject *PyObj_copy(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_TypeError, "failed to copy nonexistent object.");
+    return NULL;
+  }
+  OBJ_DATA *newobj = objCopy(obj);
+
+  // we have to put the object in the global tables and list, 
+  // or else Python will not be able to access it
+  obj_to_game(newobj);
+
+  return objGetPyForm(newobj);
+}
 
 
 
@@ -1198,20 +1212,32 @@
 
 PyMethodDef obj_module_methods[] = {
   { "read",     PyObj_read, METH_VARARGS,
-    "read an object from a storage set." },
+    "read(storage_set)\n"
+    "\n"
+    "Read and return an object from a storage set." },
   { "obj_list", (PyCFunction)PyObj_all_objs, METH_NOARGS,
-    "Return a python list containing an entry for every object in game." },
+    "obj_list()\n"
+    "\n"
+    "Return a list containing every object in the game." },
   { "load_obj", PyObj_load_obj, METH_VARARGS,
-    "load a object with the specified oproto to a room." },
+    "load_obj(prototype, where=None, equip_to='')\n"
+    "\n"
+    "Generate a new object from the specified prototype. Add it to where.\n"
+    "Where can be a room, character, or container. If where is a character,\n"
+    "add the object to the character's inventory unless a comma-separated\n"
+    "list of bodypart name of positions is specified. Return the created object." },
   { "count_objs", PyObj_count_objs, METH_VARARGS,
-    "count how many occurances of an object there are in the specified scope. "
-    "prototype or name can be used."},
+    "count_objs(keyword, loc = None)\n"
+    "\n"
+    "count how many occurences of an object with the specified keyword, uid,\n"
+    "or prototype exist at a location. If loc is None, search the entire mud.\n"
+    "Loc can be a room, character, or container object." },
   { "find_obj", PyObj_find_obj, METH_VARARGS,
-    "Takes a string argument, and returns the object(s) in the scope that "
-    "correspond to what the string is searching for."},
+    "function has been deprecated. Entrypoint for generic_find().\n"
+    "Use mud.parse_args instead." },
   { "find_obj_key", PyObj_find_obj_key, METH_VARARGS,
-    "Takes a string argument, and returns the object(s) in the scope that "
-    "are an instance of the specified class."},
+    "function has been deprecated. Entrypoint for generic_find().\n"
+    "Use mud.parse_args instead." },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -1253,77 +1279,112 @@
 
     // getters and setters
     PyObj_addGetSetter("contents", PyObj_getcontents, NULL,
-		       "the object's contents");
+      "A list of other objects contained within this one. Immutable.\n"
+      "See obj.Obj.container for changing an object's container.");
     PyObj_addGetSetter("objs", PyObj_getcontents, NULL,
-		       "the object's contents");
+      "Alias for obj.Obj.contents");
     PyObj_addGetSetter("chars", PyObj_getchars, NULL,
-		       "the characters sitting on/riding the object");
+      "A list of characters currently sitting/riding this object. Immutable.\n"
+      "See char.Char.furniture for changing a character's furniture.");
     PyObj_addGetSetter("name", PyObj_getname, PyObj_setname,
-		       "the object's name");
+      "The object's name e.g., a longsword");
     PyObj_addGetSetter("mname", PyObj_getmname, PyObj_setmname,
-		       "the object's multi-name");
+      "The object's name for describing packs, e.g.,\n"
+      "a stack of 12 linen towels. The number should be replaced by %d, or\n"
+      "not included.");
     PyObj_addGetSetter("desc", PyObj_getdesc, PyObj_setdesc,
-		       "the object's long description");
+      "An object's verbose description e.g., for when it is looked at.");
     PyObj_addGetSetter("rdesc", PyObj_getrdesc, PyObj_setrdesc,
-		       "the object's room description");
+      "The object's description when seen in a room, e.g.,\n"
+      "a longsword is here, gleaming in the sun.");
     PyObj_addGetSetter("mdesc", PyObj_getmdesc, PyObj_setmdesc,
-		       "the object's multi room description");
+      "the equivalent of mname, for room descriptions.");
     PyObj_addGetSetter("keywords", PyObj_getkeywords, PyObj_setkeywords,
-		       "the object's keywords");
+      "A comma-separated list of keywords for referencing the object.");
     PyObj_addGetSetter("weight", PyObj_getweight, PyObj_setweight,
-		       "the object's weight (plus contents)");
-    PyObj_addGetSetter("weight_raw", PyObj_get_weight_raw, NULL,
-		       "the object's weight (minus contents)");
+      "The object's weight (plus contents). When setting a new value, \n"
+      "sets raw weight (minus contents).");
+    PyObj_addGetSetter("weight_raw", PyObj_get_weight_raw, PyObj_setweight,
+      "The object's weight (minus contents)");
     PyObj_addGetSetter("uid", PyObj_getuid, NULL,
-		       "the object's unique identification number");
+      "The object's unique identification number. Immutable.");
     PyObj_addGetSetter("prototypes", PyObj_getprototypes, NULL,
-		       "a comma-separated list of this obj's prototypes.");
+      "A comma-separated list of prototypes this object inherits from. Immutable");
     PyObj_addGetSetter("bits", PyObj_getbits, PyObj_setbits,
-		       "the object's basic bitvector.");
+      "A comma-separated list of bits currently toggled for this object.");
     PyObj_addGetSetter("carrier", PyObj_getcarrier, PyObj_setcarrier,
-		       "the person carrying the object");
+      "The character whose inventory this object is currently in, or None.");
     PyObj_addGetSetter("wearer", PyObj_getwearer, NULL,
-		       "the person wearing this object");
+      "The character who is currently wearing this object, or None.");
     PyObj_addGetSetter("room", PyObj_getroom, PyObj_setroom,
-		       "The room this object is in. "
-		       "None if on a character or in another object");
+      "The room this object is current in, or None.");
     PyObj_addGetSetter("container", PyObj_getcontainer, PyObj_setcontainer,
-		       "The container this object is in. "
-		       "None if on a character or in a room");
+      "The container this object is currently in, or None.");
     PyObj_addGetSetter("hidden", PyObj_gethidden, PyObj_sethidden,
-		       "integer value representing how hidden the object is.");
+      "Integer value representing how hard this object is to see.");
     PyObj_addGetSetter("age", PyObj_getage, NULL,
-		       "how old, in seconds, are we");
+      "Value is the difference between the object's creation time and the\n"
+      "current system time. Immutable.");
     PyObj_addGetSetter("birth", PyObj_getbirth, NULL,
-		       "when were we created");
+      "Value is the object's creation time (system time). Immutable.");
 
     // methods
     PyObj_addMethod("attach", PyObj_attach, METH_VARARGS,
-		    "attach a new script to the object");
+      "attach(trigger)\n"
+      "\n"
+      "Attach a trigger to the object by key name.");
     PyObj_addMethod("detach", PyObj_detach, METH_VARARGS,
-		    "detach an old script from the object, by vnum");
+      "detach(trigger)\n"
+      "\n"
+      "Detach a trigger from the object by key name.");
     PyObj_addMethod("isinstance", PyObj_isinstance, METH_VARARGS,
-		    "checks to see if the object inherits from the class");
+      "isinstance(prototype)\n"
+      "\n"
+      "returns whether the object inherits from a specified obj prototype.");
     PyObj_addMethod("edesc", PyObj_edesc, METH_VARARGS,
-		    "adds an extra description to the object.");
+      "edesc(keywords, desc)\n"
+      "\n"
+      "Create an extra description for the object, accessible via a comma-\n"
+      "separated list of keywords.");
     PyObj_addMethod("getAuxiliary", PyObj_get_auxiliary, METH_VARARGS,
-		    "get's the specified piece of aux data from the obj");
+      "getAuxiliary(name)\n"
+      "\n"
+      "Returns object's auxiliary data of the specified name.");
     PyObj_addMethod("aux", PyObj_get_auxiliary, METH_VARARGS,
-		    "get's the specified piece of aux data from the obj");
+      "Alias for obj.Obj.getAuxiliary(name)");
     PyObj_addMethod("getvar", PyObj_getvar, METH_VARARGS,
-		    "get the value of a special variable the object has.");
+      "getvar(name)\n"
+      "\n"
+      "Return value of a special variable. Return 0 if no value has been set.");
     PyObj_addMethod("setvar", PyObj_setvar, METH_VARARGS,
-		    "set the value of a special variable the object has.");
+      "setvar(name, val)\n"
+      "\n"
+      "Set value of a special variable for the object. Values must be strings\n"
+      "or numbers. This function is intended to allow scripts and triggers to"
+      "open-endedly add variables to objects.");
     PyObj_addMethod("hasvar", PyObj_hasvar, METH_VARARGS,
-		    "return whether or not the object has a given variable.");
+      "hasvar(name)\n"
+      "\n"
+      "Return True if object has the given special variable. False otherwise.");
     PyObj_addMethod("deletevar", PyObj_deletevar, METH_VARARGS,
-		    "delete a variable from the object's variable table.");
+      "deletevar(name)\n"
+      "\n"
+      "Deletes a special variable from an object if they have one by the\n"
+      "given name.");
     PyObj_addMethod("delvar", PyObj_deletevar, METH_VARARGS,
-		    "delete a variable from the object's variable table.");
+      "Alias for obj.Obj.deletevar(name)");
     PyObj_addMethod("fromall", PyObj_fromall, METH_NOARGS,
-		    "remove from room, character, and containers.");
+      "fromall()\n"
+      "\n"
+      "Remove object from whichever room, character, or container it is in.");
     PyObj_addMethod("store", PyObj_store, METH_NOARGS,
-		    "return a storage set for the object.");
+      "store()\n"
+      "\n"
+      "Return a storage set representing the object.");
+    PyObj_addMethod("copy", PyObj_copy, METH_NOARGS,
+      "copy()\n"
+      "\n"
+      "Returns a copy of the object.");
 
     makePyType(&PyObj_Type, pyobj_getsetters, pyobj_methods);
     deleteListWith(pyobj_getsetters, free); pyobj_getsetters = NULL;
@@ -1335,7 +1396,8 @@
 
     // make the obj module
     m = Py_InitModule3("obj", obj_module_methods,
-                       "The object module, for all object-related MUD stuff.");
+      "Contains the Python wrapper for game objects. Also contains utilities\n"
+      "for listing, storing, and generating objects from prototypes.");
 
     // make sure the obj module parsed OK
     if (m == NULL)
diff -ruN ../nakedmudv3.7.9/src/scripts/pyolc.c src/scripts/pyolc.c
--- ../nakedmudv3.7.9/src/scripts/pyolc.c	2008-12-05 21:37:14.000000000 -0500
+++ src/scripts/pyolc.c	2009-04-05 13:07:11.000000000 -0400
@@ -369,15 +369,25 @@
 PyMODINIT_FUNC
 init_PyOLC(void) {
   // add all of our methods
-  PyOLC_addMethod("do_olc", pyolc_do_olc, METH_VARARGS,"Enter the OLC editor.");
+  PyOLC_addMethod("do_olc", pyolc_do_olc, METH_VARARGS,
+    "do_olc(sock, menu_func, chooser_func, parse_func, saver_func, data, autosave=False)\n\n"
+    "Entry point to the olc system. See olc2/olc.h for documentation.");
   PyOLC_addMethod("item_add_olc", pyolc_item_add_olc, METH_VARARGS, 
-		  "Add a new OLC for editing a Python item type.");
+    "item_add_olc(itemtype, menu_func, chooser_func, parse_func,\n"
+    "             fromproto_func, toproto_func)\n\n"
+    "Register a new olc handler for an item type. See items/iedit.h for\n"
+    "documentation.");
   PyOLC_addMethod("extend", pyolc_extend, METH_VARARGS,
-		  "Extends an already existing OLC command");
+    "extend(olc_type, optname, menu_func, chooser_func, parse_func = None,\n"
+    "       fromproto_func = None, toproto_func = None)\n\n"
+    "Register a new olc menu extender. Types are medit, redit, and oedit. See\n"
+    "olc2/olc_extender.h for documentation.");
 
   // create the module
   PyObject *m = Py_InitModule3("olc", makePyMethods(pyolc_methods),
-			       "The Python module for OLC.");
+    "This is the Python wrapper for the online creation module. Allows users\n"
+    "to set up new menus and handlers for editing data, such as characters,\n"
+    "while online.");
 
   // set some important OLC values as well
   PyObject_SetAttrString(m, "MENU_NOCHOICE", Py_BuildValue("i", MENU_NOCHOICE));
diff -ruN ../nakedmudv3.7.9/src/scripts/pyplugs.c src/scripts/pyplugs.c
--- ../nakedmudv3.7.9/src/scripts/pyplugs.c	2009-03-02 01:00:40.000000000 -0500
+++ src/scripts/pyplugs.c	2009-03-18 18:16:56.000000000 -0400
@@ -97,6 +97,7 @@
   if(!*arg)
     send_to_char(ch, "Which module or package would you like to load?\r\n");
   else {
+    send_to_char(ch, "{rpyload is unsafe and has been deprecated.{n\r\n");
     char fname[SMALL_BUFFER];
     sprintf(fname, "%s/%s.py", PYMOD_LIB, arg);
     // make sure the file exists
diff -ruN ../nakedmudv3.7.9/src/scripts/pyroom.c src/scripts/pyroom.c
--- ../nakedmudv3.7.9/src/scripts/pyroom.c	2009-03-02 01:00:40.000000000 -0500
+++ src/scripts/pyroom.c	2009-04-05 12:39:18.000000000 -0400
@@ -736,7 +736,7 @@
   bool interrupts = FALSE;
 
   // parse all of the values
-  if (!PyArg_ParseTuple(args, "szOsb", &name, &sort_by, &func,
+  if (!PyArg_ParseTuple(args, "szOs|b", &name, &sort_by, &func,
   			&group, &interrupts)) {
     PyErr_Format(PyExc_TypeError, 
 		 "Could not add new room command. Improper arguments supplied");
@@ -1025,7 +1025,11 @@
     0,                         /*tp_setattro*/
     0,                         /*tp_as_buffer*/
     Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
-    "Python Room object",      /* tp_doc */
+    "__init__(self, uid_or_string_key)\n\n"
+    "Creates a new Python reference to a room, by uid. If a string database\n"
+    "key is instead supplied, first try to generate a room by an rporoto of\n"
+    "the same name. If no rproto exists, create a new blank room in the room\n"
+    "table, and assign it the given key.",
     0,		               /* tp_traverse */
     0,		               /* tp_clear */
     0,		               /* tp_richcompare */
@@ -1047,13 +1051,25 @@
 
 PyMethodDef room_module_methods[] = {
   { "get_room", (PyCFunction)PyRoom_get_room, METH_VARARGS,
-    "Takes a room key/locale and returns a pointer to that room." },
+    "get_room(key)\n"
+    "\n"
+    "Takes a room key/locale and returns the matching room, or None." },
   { "is_loaded", (PyCFunction)PyRoom_loaded, METH_VARARGS,
-    "Returns whether the given room key has been loaded to the game." },
+    "is_loaded(key)\n"
+    "\n"
+    "Returns whether a room with the given key currently exists in game." },
   { "instance",  (PyCFunction)PyRoom_instance, METH_VARARGS,
-    "Returns a new instanced room to the game." },
+    "instance(room_proto, as_key = None)\n"
+    "\n"
+    "Create an instanced copy of a room, specified by a room prototype name.\n"
+    "If as_key is None, the instanced room's key will be a derivation of\n"
+    "the original prototype name, with a uid number appended to it. Otherwise\n"
+    "as_key is used for the room's key." },
   { "is_abstract",  (PyCFunction)PyRoom_is_abstract, METH_VARARGS,
-    "Returns whether a room with the specified prototype is abstract." },
+    "is_abstract(proto)\n"
+    "\n"
+    "Returns whether a specified room prototype is abstract. Also return True\n"
+    "if the prototype does not exist." },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -1097,73 +1113,122 @@
 
     // add all of the basic getsetters
     PyRoom_addGetSetter("name",    PyRoom_getname,     PyRoom_setname, 
-			"the room's name");
+      "The room's name, e.g., Town Square.");
     PyRoom_addGetSetter("desc",    PyRoom_getdesc,     PyRoom_setdesc, 
-			"the room's desc");
+      "The room's description when, e.g., looked at.");
     PyRoom_addGetSetter("proto",   PyRoom_getclass,    NULL, 
-			"The room's class");
+      "The room's unique identifier key. For non-instanced rooms, equivalent\n"
+      "to the main room prototype inherited from. Immutable.");
     PyRoom_addGetSetter("locale",  PyRoom_getlocale,   NULL, 
-			"The zone we belong to");
+      "The zone a room belongs to. Immutable.");
     PyRoom_addGetSetter("protoname",PyRoom_getprotoname,NULL, 
-			"The head of our proto");
+      "The first half of the room's unique identifier key. Immutable.");
     PyRoom_addGetSetter("protos",  PyRoom_getprotos,   NULL, 
-			"The room's prototypes");
+      "A comma-separated list of room prototypes this room inherits from. Immutable.");
     PyRoom_addGetSetter("chars",   PyRoom_getchars,    NULL, 
-			"chars in the room");
+      "A list of all characters in the room. Immutable. See char.Char.room\n"
+      "for changing the room a character is in.");
     PyRoom_addGetSetter("objs",  PyRoom_getobjs,       NULL, 
-			"objects in the room");
+      "Alias for room.Room.contents");
     PyRoom_addGetSetter("contents",PyRoom_getobjs,     NULL, 
-			"objects in the room");
+      "A list of objects in the room. Immutable. See obj.Obj.room for\n"
+      "changing the room an object is in.");
     PyRoom_addGetSetter("exnames", PyRoom_getexnames,  NULL, 
-			"the room's exits");
+      "A list of the room's exits, by direction. Immutable. See room.Room.dig\n"
+      "for creating new links between rooms.");
     PyRoom_addGetSetter("uid",     PyRoom_getuid,      NULL,
-			"the room's uid");
+      "The room's unique identification number. Immutable.");
     PyRoom_addGetSetter("terrain", PyRoom_getterrain,  PyRoom_setterrain,
-			"the room's terrain type");
+      "The current terrain type of the room.");
     PyRoom_addGetSetter("bits",    PyRoom_getbits,     PyRoom_setbits,
-			"the room's bits");
+      "A comma-separated list of setting bits currently toggled on the room.");
 
     // add all of the basic methods
     PyRoom_addMethod("attach", PyRoom_attach, METH_VARARGS,
-		     "attach a new script to the room.");
+      "attach(trigger)\n"
+      "\n"
+      "Attach a trigger to the room by key name.");
     PyRoom_addMethod("detach", PyRoom_detach, METH_VARARGS,
-		     "detach a script from the room, by vnum.");
+      "detach(trigger)\n"
+      "\n"
+      "Detach a trigger from the room by key name.");
     PyRoom_addMethod("dig", PyRoom_dig, METH_VARARGS,
-		     "digs in direction to the target room. Returns exit.");
+      "dig(dir, dest)\n"
+      "\n"
+      "Link the room to another room via the specified direction. The\n"
+      "destination room can be an actual room or a room key name. Returns\n"
+      "the created exit. If an exit already exists in the specified\n"
+      "direction, change its destination.");
     PyRoom_addMethod("fill", PyRoom_fill, METH_VARARGS,
-		     "fills in direction for the room.");
+      "fill(dir)\n"
+      "\n"
+      "Erases an exit in the specified direction.");
     PyRoom_addMethod("exit", PyRoom_get_exit, METH_VARARGS,
-		     "gets an exit in the room with the given direction name.");
+      "exit(dir)\n"
+      "\n"
+      "Returns an exit for the specified direction, or None.");
     PyRoom_addMethod("exdir", PyRoom_get_exit_dir, METH_VARARGS,
-		     "returns the direction of the exit.");
+      "exdir(exit)\n"
+      "\n"
+      "Returns the direction for a specified exit, or None.");
     PyRoom_addMethod("send", PyRoom_send, METH_VARARGS,
-		     "send a message to everyone in the room.");
+      "send(mssg)\n"
+      "\n"
+      "Send a message to all characters in the room.");
     PyRoom_addMethod("edesc", PyRoom_edesc, METH_VARARGS,
-		     "adds an extra description to the room.");
+      "edesc(keywords, desc)\n"
+      "\n"
+      "Create an extra description for the room, accessible via a comma-\n"
+      "separated list of keywords.");
     PyRoom_addMethod("add_cmd", PyRoom_add_cmd, METH_VARARGS,
-		     "adds a command to the room.");
+      "add_cmd(name, shorthand, cmd_func, user_group, interrupts = False)\n"
+      "\n"
+      "Add a new player command specific to the room. See mudsys.add_cmd for\n"
+      "documentation on commands.");
     PyRoom_addMethod("add_cmd_check", PyRoom_add_cmd_check, METH_VARARGS,
-		     "adds a pre-check to a room command.");
+      "add_cmd_check(cmd_name, check_func)\n"
+      "\n"
+      "Add a new command check function specific to the room. See \n"
+      "mudsys.add_cmd_check for documentation on command checks.");
     PyRoom_addMethod("isinstance", PyRoom_isinstance, METH_VARARGS,
-		     "returns whether or not the room inherits from the proto");
+      "isinstance(prototype)\n"
+      "\n"
+      "returns whether the room inherits from a specified room prototype.");
     PyRoom_addMethod("getAuxiliary", PyRoom_get_auxiliary, METH_VARARGS,
-		     "get's the specified piece of aux data from the room");
+      "getAuxiliary(name)\n"
+      "\n"
+      "Returns room's auxiliary data of the specified name.");
     PyRoom_addMethod("aux", PyRoom_get_auxiliary, METH_VARARGS,
-		     "get's the specified piece of aux data from the room");
+      "Alias for room.Room.getAuxiliary(name)");
     PyRoom_addMethod("getvar", PyRoom_getvar, METH_VARARGS,
-		    "get the value of a special variable the room has.");
+      "getvar(name)\n"
+      "\n"
+      "Return value of a special variable. Return 0 if no value has been set.");
     PyRoom_addMethod("setvar", PyRoom_setvar, METH_VARARGS,
-		    "set the value of a special variable the room has.");
+      "setvar(name, val)\n"
+      "\n"
+      "Set value of a special variable for the room. Values must be strings \n"
+      "or numbers. This function is intended to allow scripts and triggers to"
+      "open-endedly add variables to rooms.");
     PyRoom_addMethod("hasvar", PyRoom_hasvar, METH_VARARGS,
-		    "return whether or not the room has a given variable.");
+      "hasvar(name)\n"
+      "\n"
+      "Return True if a room has the given special variable. False otherwise.");
     PyRoom_addMethod("deletevar", PyRoom_deletevar, METH_VARARGS,
-		    "delete a variable from the room's variable table.");
+      "deletevar(name)\n"
+      "\n"
+      "Deletes a special variable from a room if they have one by the\n"
+      "given name.");
     PyRoom_addMethod("delvar", PyRoom_deletevar, METH_VARARGS,
-		    "delete a variable from the room's variable table.");
+      "Alias for room.Room.deletevar(name)");
     PyRoom_addMethod("reset", PyRoom_reset, METH_NOARGS,
-		     "run all of the room's reset commands.");
+      "reset()\n"
+      "\n"
+      "Runs a room's reset commands and reset hooks.");
     PyRoom_addMethod("hasBit", PyRoom_hasBit, METH_VARARGS,
-		     "return whether or not the room has a specified bit.");
+      "hasBit(name)\n"
+      "\n"
+      "Return whether room has a bit toggled.\n");
 
     // add in all the getsetters and methods
     makePyType(&PyRoom_Type, pyroom_getsetters, pyroom_methods);
@@ -1176,7 +1241,8 @@
 
     // initialize the module
     module = Py_InitModule3("room", room_module_methods,
-			    "The room module, for all MUD room-related stuff.");
+      "Contains the Python wrapper for rooms, and utilities for loading and\n"
+      "instancing rooms.");
 
     // make sure the module parsed OK
     if (module == NULL)
diff -ruN ../nakedmudv3.7.9/src/scripts/pysocket.c src/scripts/pysocket.c
--- ../nakedmudv3.7.9/src/scripts/pysocket.c	2009-03-02 01:00:40.000000000 -0500
+++ src/scripts/pysocket.c	2009-04-05 12:41:04.000000000 -0400
@@ -418,6 +418,7 @@
 
 PyMethodDef socket_module_methods[] = {
   { "socket_list", (PyCFunction)PySocket_all_sockets, METH_NOARGS,
+    "socket_list()\n\n"
     "Returns a list of all sockets currently connected." },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
@@ -461,52 +462,70 @@
 
     // add all of the basic getsetters
     PySocket_addGetSetter("uid", PySocket_getuid, NULL,
-			   "the socket's uid.");
+      "The socket's uid. Immutable.");
     PySocket_addGetSetter("account", PySocket_getaccount, NULL,
-			   "the socket's account.");
+      "The account currently attached to the socket, or None. Immutable.\n"
+      "see mudsys.attach_account_socket for connecting sockets and accounts.");
     PySocket_addGetSetter("character", PySocket_getchar, NULL,
-			   "the socket's character.");
+      "The character currently attached to the socket, on None. Immutable.\n"
+      "see mudsys.attach_char_socket for connecting characters to account.");
     PySocket_addGetSetter("char", PySocket_getchar, NULL,
-			   "the socket's character.");
+       "Alias for mudsock.Mudsock.character");
     PySocket_addGetSetter("ch",   PySocket_getchar, NULL,
-			   "the socket's character.");
+       "Alias for mudsock.Mudsock.character.");
     PySocket_addGetSetter("has_input", PySocket_getcmdread, NULL,
-			  "Have we read any input this iteration?");
+       "True or False if the socket has any input pending. Immutable.");
     PySocket_addGetSetter("outbound_text",
-			  PySocket_get_outbound_text,PySocket_set_outbound_text,
-			  "the socket's outbound text.");
-    PySocket_addGetSetter("can_use",
-			  PySocket_get_can_use, NULL,
-			  "Returns whether or not the socket is ready for use. "
-			  "Sockets become available after their dns resolves.");
+       PySocket_get_outbound_text, PySocket_set_outbound_text,
+       "The socket's outbound text.");
+    PySocket_addGetSetter("can_use", PySocket_get_can_use, NULL,
+      "True or False if the socket is ready for use. Socket becomes available\n"
+      "after its dns addresss resolves. Immutable.");
     PySocket_addGetSetter("state", PySocket_getstate, NULL,
-			  "Returns the state that the socket is in.");
+      "The state that the socket is in. Immutable. For more on states see\n"
+      "mudsock.Mudsock.push_ih");
     PySocket_addGetSetter("idle_time", PySocket_getidletime, NULL,
-			  "Returns how long (seconds) we've been idle.");
+      "How long (in seconds) the socket's input handler has been idle for. Immutable.");
     PySocket_addGetSetter("hostname", PySocket_gethostname, NULL,
-			  "return where we are connected from.");
+      "The dns address that the socket is connected from. Immutable.");
 
     // add all of the basic methods
     PySocket_addMethod("getAuxiliary", PySocket_get_auxiliary, METH_VARARGS,
-		       "gets the socket auxiliary data with given key.");
+      "getAuxiliary(name)\n\n"
+      "Returns socket's auxiliary data of the specified name.");
     PySocket_addMethod("aux", PySocket_get_auxiliary, METH_VARARGS,
-		       "gets the socket auxiliary data with given key.");
+      "Alias for mudsock.Mudsock.getAuxiliary");
     PySocket_addMethod("send", PySocket_send, METH_VARARGS,
-		       "sends text to the socket with appended newline.");
+      "send(mssg)\n\n"
+      "Sends text to the socket with appended newline.");
     PySocket_addMethod("send_raw", PySocket_send_raw, METH_VARARGS,
-		       "sends text to the socket.");
+      "send_raw(mssg)\n\n"
+      "Sends text to the socket. No appended newline.");
     PySocket_addMethod("pop_ih", PySocket_pop_ih, METH_NOARGS,
-			"Pops the socket's current input handler.");
+      "pop_ih()\n\n"
+      "Pops the socket's current input handler from its input handler stack.");
     PySocket_addMethod("push_ih", PySocket_push_ih, METH_VARARGS,
-			"pushes on a new input handler.");
+      "push_ih(handler_func, prompt_func, state=None)\n\n"
+      "Pushes a new input handler and prompt pair onto the socket's input\n"
+      "handler stack. Optionally, a (String) state value can be supplied.\n"
+      "Input handlers take two arguments: the socket and a string command.\n"
+      "Prompts take one argument: the socket. They should send the relevant\n"
+      "text for the prompt to the socket.");
     PySocket_addMethod("replace_ih", PySocket_replace_ih, METH_VARARGS,
-		       "replaces the socket's input handler.");
+      "repalce_ih(handler_func, prompt_func, state=None)\n\n"
+      "Calls pop_ih, followed by push_ih.");
     PySocket_addMethod("close", PySocket_close, METH_VARARGS,
-		       "closes the socket.");
+      "close()\n\n"
+      "Closes the socket's connection.");
     PySocket_addMethod("bust_prompt", PySocket_bust_prompt, METH_NOARGS,
-		       "busts the socket's prompt so it will be displayed.");
+      "bust_prompt()\n\n"
+      "Busts the socket's prompt so it will be displayed next pulse.");
     PySocket_addMethod("edit_text", PySocket_edit_text, METH_VARARGS, 
-		       "enter the text editor and begin editing something.");
+      "edit_text(dflt_value, on_complete, mode='text')\n\n"
+      "Enter the text editor, and set its default value. When the text editor\n"
+      "is edited, call on_complete. This function should take two arguments:\n"
+      "the socket doing the editing, and the output of the editor. Mode can\n"
+      "be 'text' or 'script'.");
 
     // add in all the getsetters and methods
     makePyType(&PySocket_Type, pysocket_getsetters, pysocket_methods);
@@ -519,8 +538,8 @@
 
     // initialize the module
     module = Py_InitModule3("mudsock", socket_module_methods,
-			    "The socket module, for all MUD socket-related "
-			    "stuff.");
+      "Contains the Python wrapper for sockets, and utilities for listing\n"
+      "currently connected sockets.");
 
     // make sure the module parsed OK
     if (module == NULL)
